OpenShot Audio Library | OpenShotAudio: juce::SharedResourcePointer< SharedObjectType > Class Template Reference

OpenShot Audio Library | OpenShotAudio 1.0.0

Loading...
Searching...
No Matches
juce::SharedResourcePointer< SharedObjectType > Class Template Reference

`#include <juce_SharedResourcePointer.h>`

## Public Member Functions
| SharedResourcePointer ()=default
| SharedResourcePointer (const SharedResourcePointer &)=default
| SharedResourcePointer (SharedResourcePointer &&) noexcept=default
| ~SharedResourcePointer ()=default
| operator SharedObjectType * () const noexcept
SharedObjectType & | get () const noexcept
SharedObjectType & | getObject () const noexcept
SharedObjectType * | operator-> () const noexcept
SharedObjectType & | operator* () const noexcept
int | getReferenceCount () const noexcept

## Static Public Member Functions
static std::optional< SharedResourcePointer > | getSharedObjectWithoutCreating ()

## Detailed Description

template<typename SharedObjectType>
class juce::SharedResourcePointer< SharedObjectType >

A smart-pointer that automatically creates and manages the lifetime of a shared static instance of a class.

The SharedObjectType template type indicates the class to use for the shared object - the only requirements on this class are that it must have a public default constructor and destructor.

The SharedResourcePointer offers a pattern that differs from using a singleton or static instance of an object, because it uses reference-counting to make sure that the underlying shared object is automatically created/destroyed according to the number of SharedResourcePointer objects that exist. When the last one is deleted, the underlying object is also immediately destroyed. This allows you to use scoping to manage the lifetime of a shared resource.

Note: The construction/deletion of the shared object must not involve any code that makes recursive calls to a SharedResourcePointer, or you'll cause a deadlock.

Example:

// An example of a class that contains the shared data you want to use.
struct MySharedData
{
// There's no need to ever create an instance of this class directly yourself,
// but it does need a public constructor that does the initialisation.
MySharedData()
{
sharedStuff = generateHeavyweightStuff();
}
Array<SomeKindOfData> sharedStuff;
};
struct DataUserClass
{
DataUserClass()
{
// Multiple instances of the DataUserClass will all have the same
// shared common instance of MySharedData referenced by their sharedData
// member variables.
useSharedStuff (sharedData->sharedStuff);
}
// By keeping this pointer as a member variable, the shared resource
// is guaranteed to be available for as long as the DataUserClass object.
SharedResourcePointer<MySharedData> sharedData;
};
juce::Array
Definition juce_Array.h:56

Definition at line 81 of file juce_SharedResourcePointer.h.

## Constructor & Destructor Documentation

## ◆ SharedResourcePointer() [1/3]

template<typename SharedObjectType>

juce::SharedResourcePointer< SharedObjectType >::SharedResourcePointer | ( |  | ) |
| default

Creates an instance of the shared object. If other SharedResourcePointer objects for this type already exist, then this one will simply point to the same shared object that they are already using. Otherwise, if this is the first SharedResourcePointer to be created, then a shared object will be created automatically.

Referenced by getSharedObjectWithoutCreating(), SharedResourcePointer(), SharedResourcePointer(), and ~SharedResourcePointer().

## ◆ SharedResourcePointer() [2/3]

template<typename SharedObjectType>

juce::SharedResourcePointer< SharedObjectType >::SharedResourcePointer | ( | const SharedResourcePointer< SharedObjectType > & |  | ) |
| default

Copy constructor.

## ◆ SharedResourcePointer() [3/3]

template<typename SharedObjectType>

juce::SharedResourcePointer< SharedObjectType >::SharedResourcePointer | ( | SharedResourcePointer< SharedObjectType > && |  | ) |
| defaultnoexcept

Move constructor.

## ◆ ~SharedResourcePointer()

template<typename SharedObjectType>

juce::SharedResourcePointer< SharedObjectType >::~SharedResourcePointer | ( |  | ) |
| default

Destructor. If no other SharedResourcePointer objects exist, this will also delete the shared object to which it refers.

## Member Function Documentation

## ◆ get()

template<typename SharedObjectType>

SharedObjectType & juce::SharedResourcePointer< SharedObjectType >::get | ( |  | ) | const
| inlinenoexcept

Returns a reference to the shared object.

Definition at line 108 of file juce_SharedResourcePointer.h.

## ◆ getObject()

template<typename SharedObjectType>

SharedObjectType & juce::SharedResourcePointer< SharedObjectType >::getObject | ( |  | ) | const
| inlinenoexcept

Returns a reference to the shared object.

Definition at line 111 of file juce_SharedResourcePointer.h.

## ◆ getReferenceCount()

template<typename SharedObjectType>

int juce::SharedResourcePointer< SharedObjectType >::getReferenceCount | ( |  | ) | const
| inlinenoexcept

Deprecated
  If you are relying on this function please inform the JUCE team as we are planing on removing this in a subsequent release

Definition at line 121 of file juce_SharedResourcePointer.h.

## ◆ getSharedObjectWithoutCreating()

template<typename SharedObjectType>

std::optional< SharedResourcePointer > juce::SharedResourcePointer< SharedObjectType >::getSharedObjectWithoutCreating | ( |  | ) |
| inlinestatic

Returns the SharedResourcePointer if one already exists, or a null optional otherwise.

Definition at line 125 of file juce_SharedResourcePointer.h.

Referenced by juce::Timer::callPendingTimersSynchronously().

## ◆ operator SharedObjectType *()

template<typename SharedObjectType>

juce::SharedResourcePointer< SharedObjectType >::operator SharedObjectType * | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the shared object.

Definition at line 105 of file juce_SharedResourcePointer.h.

## ◆ operator*()

template<typename SharedObjectType>

SharedObjectType & juce::SharedResourcePointer< SharedObjectType >::operator* | ( |  | ) | const
| inlinenoexcept

Returns a reference to the shared object.

Definition at line 117 of file juce_SharedResourcePointer.h.

## ◆ operator->()

template<typename SharedObjectType>

SharedObjectType * juce::SharedResourcePointer< SharedObjectType >::operator-> | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the shared object.

Definition at line 114 of file juce_SharedResourcePointer.h.

The documentation for this class was generated from the following file:

- juce_SharedResourcePointer.h